Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -26,4 +26,1386 @@
 
     /*************************************************************************
+    This object stores state of the nonlinear CG optimizer.
+
+    You should use ALGLIB functions to work with this object.
+    *************************************************************************/
+    public class mincgstate
+    {
+        //
+        // Public declarations
+        //
+        public bool needf { get { return _innerobj.needf; } set { _innerobj.needf = value; } }
+        public bool needfg { get { return _innerobj.needfg; } set { _innerobj.needfg = value; } }
+        public bool xupdated { get { return _innerobj.xupdated; } set { _innerobj.xupdated = value; } }
+        public double f { get { return _innerobj.f; } set { _innerobj.f = value; } }
+        public double[] g { get { return _innerobj.g; } }
+        public double[] x { get { return _innerobj.x; } }
+
+        public mincgstate()
+        {
+            _innerobj = new mincg.mincgstate();
+        }
+
+        //
+        // Although some of declarations below are public, you should not use them
+        // They are intended for internal use only
+        //
+        private mincg.mincgstate _innerobj;
+        public mincg.mincgstate innerobj { get { return _innerobj; } }
+        public mincgstate(mincg.mincgstate obj)
+        {
+            _innerobj = obj;
+        }
+    }
+
+
+    /*************************************************************************
+
+    *************************************************************************/
+    public class mincgreport
+    {
+        //
+        // Public declarations
+        //
+        public int iterationscount { get { return _innerobj.iterationscount; } set { _innerobj.iterationscount = value; } }
+        public int nfev { get { return _innerobj.nfev; } set { _innerobj.nfev = value; } }
+        public int terminationtype { get { return _innerobj.terminationtype; } set { _innerobj.terminationtype = value; } }
+
+        public mincgreport()
+        {
+            _innerobj = new mincg.mincgreport();
+        }
+
+        //
+        // Although some of declarations below are public, you should not use them
+        // They are intended for internal use only
+        //
+        private mincg.mincgreport _innerobj;
+        public mincg.mincgreport innerobj { get { return _innerobj; } }
+        public mincgreport(mincg.mincgreport obj)
+        {
+            _innerobj = obj;
+        }
+    }
+
+    /*************************************************************************
+            NONLINEAR CONJUGATE GRADIENT METHOD
+
+    DESCRIPTION:
+    The subroutine minimizes function F(x) of N arguments by using one of  the
+    nonlinear conjugate gradient methods.
+
+    These CG methods are globally convergent (even on non-convex functions) as
+    long as grad(f) is Lipschitz continuous in  a  some  neighborhood  of  the
+    L = { x : f(x)<=f(x0) }.
+
+
+    REQUIREMENTS:
+    Algorithm will request following information during its operation:
+    * function value F and its gradient G (simultaneously) at given point X
+
+
+    USAGE:
+    1. User initializes algorithm state with MinCGCreate() call
+    2. User tunes solver parameters with MinCGSetCond(), MinCGSetStpMax() and
+       other functions
+    3. User calls MinCGOptimize() function which takes algorithm  state   and
+       pointer (delegate, etc.) to callback function which calculates F/G.
+    4. User calls MinCGResults() to get solution
+    5. Optionally, user may call MinCGRestartFrom() to solve another  problem
+       with same N but another starting point and/or another function.
+       MinCGRestartFrom() allows to reuse already initialized structure.
+
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>0:
+                    * if given, only leading N elements of X are used
+                    * if not given, automatically determined from size of X
+        X       -   starting point, array[0..N-1].
+
+    OUTPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+      -- ALGLIB --
+         Copyright 25.03.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgcreate(int n, double[] x, out mincgstate state)
+    {
+        state = new mincgstate();
+        mincg.mincgcreate(n, x, state.innerobj);
+        return;
+    }
+    public static void mincgcreate(double[] x, out mincgstate state)
+    {
+        int n;
+
+        state = new mincgstate();
+        n = ap.len(x);
+        mincg.mincgcreate(n, x, state.innerobj);
+
+        return;
+    }
+
+    /*************************************************************************
+    The subroutine is finite difference variant of MinCGCreate(). It uses
+    finite differences in order to differentiate target function.
+
+    Description below contains information which is specific to this function
+    only. We recommend to read comments on MinCGCreate() in order to get more
+    information about creation of CG optimizer.
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>0:
+                    * if given, only leading N elements of X are used
+                    * if not given, automatically determined from size of X
+        X       -   starting point, array[0..N-1].
+        DiffStep-   differentiation step, >0
+
+    OUTPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+    NOTES:
+    1. algorithm uses 4-point central formula for differentiation.
+    2. differentiation step along I-th axis is equal to DiffStep*S[I] where
+       S[] is scaling vector which can be set by MinCGSetScale() call.
+    3. we recommend you to use moderate values of  differentiation  step.  Too
+       large step will result in too large truncation  errors, while too small
+       step will result in too large numerical  errors.  1.0E-6  can  be  good
+       value to start with.
+    4. Numerical  differentiation  is   very   inefficient  -   one   gradient
+       calculation needs 4*N function evaluations. This function will work for
+       any N - either small (1...10), moderate (10...100) or  large  (100...).
+       However, performance penalty will be too severe for any N's except  for
+       small ones.
+       We should also say that code which relies on numerical  differentiation
+       is  less  robust  and  precise.  L-BFGS  needs  exact  gradient values.
+       Imprecise  gradient may slow down  convergence,  especially  on  highly
+       nonlinear problems.
+       Thus  we  recommend to use this function for fast prototyping on small-
+       dimensional problems only, and to implement analytical gradient as soon
+       as possible.
+
+      -- ALGLIB --
+         Copyright 16.05.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgcreatef(int n, double[] x, double diffstep, out mincgstate state)
+    {
+        state = new mincgstate();
+        mincg.mincgcreatef(n, x, diffstep, state.innerobj);
+        return;
+    }
+    public static void mincgcreatef(double[] x, double diffstep, out mincgstate state)
+    {
+        int n;
+
+        state = new mincgstate();
+        n = ap.len(x);
+        mincg.mincgcreatef(n, x, diffstep, state.innerobj);
+
+        return;
+    }
+
+    /*************************************************************************
+    This function sets stopping conditions for CG optimization algorithm.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        EpsG    -   >=0
+                    The  subroutine  finishes  its  work   if   the  condition
+                    |v|<EpsG is satisfied, where:
+                    * |.| means Euclidian norm
+                    * v - scaled gradient vector, v[i]=g[i]*s[i]
+                    * g - gradient
+                    * s - scaling coefficients set by MinCGSetScale()
+        EpsF    -   >=0
+                    The  subroutine  finishes  its work if on k+1-th iteration
+                    the  condition  |F(k+1)-F(k)|<=EpsF*max{|F(k)|,|F(k+1)|,1}
+                    is satisfied.
+        EpsX    -   >=0
+                    The subroutine finishes its work if  on  k+1-th  iteration
+                    the condition |v|<=EpsX is fulfilled, where:
+                    * |.| means Euclidian norm
+                    * v - scaled step vector, v[i]=dx[i]/s[i]
+                    * dx - ste pvector, dx=X(k+1)-X(k)
+                    * s - scaling coefficients set by MinCGSetScale()
+        MaxIts  -   maximum number of iterations. If MaxIts=0, the  number  of
+                    iterations is unlimited.
+
+    Passing EpsG=0, EpsF=0, EpsX=0 and MaxIts=0 (simultaneously) will lead to
+    automatic stopping criterion selection (small EpsX).
+
+      -- ALGLIB --
+         Copyright 02.04.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsetcond(mincgstate state, double epsg, double epsf, double epsx, int maxits)
+    {
+
+        mincg.mincgsetcond(state.innerobj, epsg, epsf, epsx, maxits);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets scaling coefficients for CG optimizer.
+
+    ALGLIB optimizers use scaling matrices to test stopping  conditions  (step
+    size and gradient are scaled before comparison with tolerances).  Scale of
+    the I-th variable is a translation invariant measure of:
+    a) "how large" the variable is
+    b) how large the step should be to make significant changes in the function
+
+    Scaling is also used by finite difference variant of CG optimizer  -  step
+    along I-th axis is equal to DiffStep*S[I].
+
+    In   most   optimizers  (and  in  the  CG  too)  scaling is NOT a form  of
+    preconditioning. It just  affects  stopping  conditions.  You  should  set
+    preconditioner by separate call to one of the MinCGSetPrec...() functions.
+
+    There  is  special  preconditioning  mode, however,  which  uses   scaling
+    coefficients to form diagonal preconditioning matrix. You  can  turn  this
+    mode on, if you want.   But  you should understand that scaling is not the
+    same thing as preconditioning - these are two different, although  related
+    forms of tuning solver.
+
+    INPUT PARAMETERS:
+        State   -   structure stores algorithm state
+        S       -   array[N], non-zero scaling coefficients
+                    S[i] may be negative, sign doesn't matter.
+
+      -- ALGLIB --
+         Copyright 14.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsetscale(mincgstate state, double[] s)
+    {
+
+        mincg.mincgsetscale(state.innerobj, s);
+        return;
+    }
+
+    /*************************************************************************
+    This function turns on/off reporting.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        NeedXRep-   whether iteration reports are needed or not
+
+    If NeedXRep is True, algorithm will call rep() callback function if  it is
+    provided to MinCGOptimize().
+
+      -- ALGLIB --
+         Copyright 02.04.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsetxrep(mincgstate state, bool needxrep)
+    {
+
+        mincg.mincgsetxrep(state.innerobj, needxrep);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets CG algorithm.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        CGType  -   algorithm type:
+                    * -1    automatic selection of the best algorithm
+                    * 0     DY (Dai and Yuan) algorithm
+                    * 1     Hybrid DY-HS algorithm
+
+      -- ALGLIB --
+         Copyright 02.04.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsetcgtype(mincgstate state, int cgtype)
+    {
+
+        mincg.mincgsetcgtype(state.innerobj, cgtype);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets maximum step length
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        StpMax  -   maximum step length, >=0. Set StpMax to 0.0,  if you don't
+                    want to limit step length.
+
+    Use this subroutine when you optimize target function which contains exp()
+    or  other  fast  growing  functions,  and optimization algorithm makes too
+    large  steps  which  leads  to overflow. This function allows us to reject
+    steps  that  are  too  large  (and  therefore  expose  us  to the possible
+    overflow) without actually calculating function value at the x+stp*d.
+
+      -- ALGLIB --
+         Copyright 02.04.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsetstpmax(mincgstate state, double stpmax)
+    {
+
+        mincg.mincgsetstpmax(state.innerobj, stpmax);
+        return;
+    }
+
+    /*************************************************************************
+    This function allows to suggest initial step length to the CG algorithm.
+
+    Suggested  step  length  is used as starting point for the line search. It
+    can be useful when you have  badly  scaled  problem,  i.e.  when  ||grad||
+    (which is used as initial estimate for the first step) is many  orders  of
+    magnitude different from the desired step.
+
+    Line search  may  fail  on  such problems without good estimate of initial
+    step length. Imagine, for example, problem with ||grad||=10^50 and desired
+    step equal to 0.1 Line  search function will use 10^50  as  initial  step,
+    then  it  will  decrease step length by 2 (up to 20 attempts) and will get
+    10^44, which is still too large.
+
+    This function allows us to tell than line search should  be  started  from
+    some moderate step length, like 1.0, so algorithm will be able  to  detect
+    desired step length in a several searches.
+
+    Default behavior (when no step is suggested) is to use preconditioner,  if
+    it is available, to generate initial estimate of step length.
+
+    This function influences only first iteration of algorithm. It  should  be
+    called between MinCGCreate/MinCGRestartFrom() call and MinCGOptimize call.
+    Suggested step is ignored if you have preconditioner.
+
+    INPUT PARAMETERS:
+        State   -   structure used to store algorithm state.
+        Stp     -   initial estimate of the step length.
+                    Can be zero (no estimate).
+
+      -- ALGLIB --
+         Copyright 30.07.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsuggeststep(mincgstate state, double stp)
+    {
+
+        mincg.mincgsuggeststep(state.innerobj, stp);
+        return;
+    }
+
+    /*************************************************************************
+    Modification of the preconditioner: preconditioning is turned off.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+    NOTE:  you  can  change  preconditioner  "on  the  fly",  during algorithm
+    iterations.
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsetprecdefault(mincgstate state)
+    {
+
+        mincg.mincgsetprecdefault(state.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Modification  of  the  preconditioner:  diagonal of approximate Hessian is
+    used.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        D       -   diagonal of the approximate Hessian, array[0..N-1],
+                    (if larger, only leading N elements are used).
+
+    NOTE:  you  can  change  preconditioner  "on  the  fly",  during algorithm
+    iterations.
+
+    NOTE 2: D[i] should be positive. Exception will be thrown otherwise.
+
+    NOTE 3: you should pass diagonal of approximate Hessian - NOT ITS INVERSE.
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsetprecdiag(mincgstate state, double[] d)
+    {
+
+        mincg.mincgsetprecdiag(state.innerobj, d);
+        return;
+    }
+
+    /*************************************************************************
+    Modification of the preconditioner: scale-based diagonal preconditioning.
+
+    This preconditioning mode can be useful when you  don't  have  approximate
+    diagonal of Hessian, but you know that your  variables  are  badly  scaled
+    (for  example,  one  variable is in [1,10], and another in [1000,100000]),
+    and most part of the ill-conditioning comes from different scales of vars.
+
+    In this case simple  scale-based  preconditioner,  with H[i] = 1/(s[i]^2),
+    can greatly improve convergence.
+
+    IMPRTANT: you should set scale of your variables with MinCGSetScale() call
+    (before or after MinCGSetPrecScale() call). Without knowledge of the scale
+    of your variables scale-based preconditioner will be just unit matrix.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+    NOTE:  you  can  change  preconditioner  "on  the  fly",  during algorithm
+    iterations.
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgsetprecscale(mincgstate state)
+    {
+
+        mincg.mincgsetprecscale(state.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    This function provides reverse communication interface
+    Reverse communication interface is not documented or recommended to use.
+    See below for functions which provide better documented API
+    *************************************************************************/
+    public static bool mincgiteration(mincgstate state)
+    {
+
+        bool result = mincg.mincgiteration(state.innerobj);
+        return result;
+    }
+    /*************************************************************************
+    This family of functions is used to launcn iterations of nonlinear optimizer
+
+    These functions accept following parameters:
+        func    -   callback which calculates function (or merit function)
+                    value func at given point x
+        grad    -   callback which calculates function (or merit function)
+                    value func and gradient grad at given point x
+        rep     -   optional callback which is called after each iteration
+                    can be null
+        obj     -   optional object which is passed to func/grad/hess/jac/rep
+                    can be null
+
+    NOTES:
+
+    1. This function has two different implementations: one which  uses  exact
+       (analytical) user-supplied  gradient, and one which uses function value
+       only  and  numerically  differentiates  function  in  order  to  obtain
+       gradient.
+
+       Depending  on  the  specific  function  used to create optimizer object
+       (either MinCGCreate()  for analytical gradient  or  MinCGCreateF()  for
+       numerical differentiation) you should  choose  appropriate  variant  of
+       MinCGOptimize() - one which accepts function AND gradient or one  which
+       accepts function ONLY.
+
+       Be careful to choose variant of MinCGOptimize()  which  corresponds  to
+       your optimization scheme! Table below lists different  combinations  of
+       callback (function/gradient) passed  to  MinCGOptimize()  and  specific
+       function used to create optimizer.
+
+
+                      |         USER PASSED TO MinCGOptimize()
+       CREATED WITH   |  function only   |  function and gradient
+       ------------------------------------------------------------
+       MinCGCreateF() |     work                FAIL
+       MinCGCreate()  |     FAIL                work
+
+       Here "FAIL" denotes inappropriate combinations  of  optimizer  creation
+       function and MinCGOptimize() version. Attemps to use  such  combination
+       (for  example,  to create optimizer with  MinCGCreateF()  and  to  pass
+       gradient information to MinCGOptimize()) will lead to  exception  being
+       thrown. Either  you  did  not  pass  gradient when it WAS needed or you
+       passed gradient when it was NOT needed.
+
+      -- ALGLIB --
+         Copyright 20.04.2009 by Bochkanov Sergey
+
+    *************************************************************************/
+    public static void mincgoptimize(mincgstate state, ndimensional_func func, ndimensional_rep rep, object obj)
+    {
+        if( func==null )
+            throw new alglibexception("ALGLIB: error in 'mincgoptimize()' (func is null)");
+        while( alglib.mincgiteration(state) )
+        {
+            if( state.needf )
+            {
+                func(state.x, ref state.innerobj.f, obj);
+                continue;
+            }
+            if( state.innerobj.xupdated )
+            {
+                if( rep!=null )
+                    rep(state.innerobj.x, state.innerobj.f, obj);
+                continue;
+            }
+            throw new alglibexception("ALGLIB: error in 'mincgoptimize' (some derivatives were not provided?)");
+        }
+    }
+
+
+    public static void mincgoptimize(mincgstate state, ndimensional_grad grad, ndimensional_rep rep, object obj)
+    {
+        if( grad==null )
+            throw new alglibexception("ALGLIB: error in 'mincgoptimize()' (grad is null)");
+        while( alglib.mincgiteration(state) )
+        {
+            if( state.needfg )
+            {
+                grad(state.x, ref state.innerobj.f, state.innerobj.g, obj);
+                continue;
+            }
+            if( state.innerobj.xupdated )
+            {
+                if( rep!=null )
+                    rep(state.innerobj.x, state.innerobj.f, obj);
+                continue;
+            }
+            throw new alglibexception("ALGLIB: error in 'mincgoptimize' (some derivatives were not provided?)");
+        }
+    }
+
+
+
+    /*************************************************************************
+    Conjugate gradient results
+
+    INPUT PARAMETERS:
+        State   -   algorithm state
+
+    OUTPUT PARAMETERS:
+        X       -   array[0..N-1], solution
+        Rep     -   optimization report:
+                    * Rep.TerminationType completetion code:
+                        *  1    relative function improvement is no more than
+                                EpsF.
+                        *  2    relative step is no more than EpsX.
+                        *  4    gradient norm is no more than EpsG
+                        *  5    MaxIts steps was taken
+                        *  7    stopping conditions are too stringent,
+                                further improvement is impossible,
+                                we return best X found so far
+                        *  8    terminated by user
+                    * Rep.IterationsCount contains iterations count
+                    * NFEV countains number of function calculations
+
+      -- ALGLIB --
+         Copyright 20.04.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgresults(mincgstate state, out double[] x, out mincgreport rep)
+    {
+        x = new double[0];
+        rep = new mincgreport();
+        mincg.mincgresults(state.innerobj, ref x, rep.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Conjugate gradient results
+
+    Buffered implementation of MinCGResults(), which uses pre-allocated buffer
+    to store X[]. If buffer size is  too  small,  it  resizes  buffer.  It  is
+    intended to be used in the inner cycles of performance critical algorithms
+    where array reallocation penalty is too large to be ignored.
+
+      -- ALGLIB --
+         Copyright 20.04.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgresultsbuf(mincgstate state, ref double[] x, mincgreport rep)
+    {
+
+        mincg.mincgresultsbuf(state.innerobj, ref x, rep.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    This  subroutine  restarts  CG  algorithm from new point. All optimization
+    parameters are left unchanged.
+
+    This  function  allows  to  solve multiple  optimization  problems  (which
+    must have same number of dimensions) without object reallocation penalty.
+
+    INPUT PARAMETERS:
+        State   -   structure used to store algorithm state.
+        X       -   new starting point.
+
+      -- ALGLIB --
+         Copyright 30.07.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mincgrestartfrom(mincgstate state, double[] x)
+    {
+
+        mincg.mincgrestartfrom(state.innerobj, x);
+        return;
+    }
+
+}
+public partial class alglib
+{
+
+
+    /*************************************************************************
+    This object stores nonlinear optimizer state.
+    You should use functions provided by MinBLEIC subpackage to work with this
+    object
+    *************************************************************************/
+    public class minbleicstate
+    {
+        //
+        // Public declarations
+        //
+        public bool needf { get { return _innerobj.needf; } set { _innerobj.needf = value; } }
+        public bool needfg { get { return _innerobj.needfg; } set { _innerobj.needfg = value; } }
+        public bool xupdated { get { return _innerobj.xupdated; } set { _innerobj.xupdated = value; } }
+        public double f { get { return _innerobj.f; } set { _innerobj.f = value; } }
+        public double[] g { get { return _innerobj.g; } }
+        public double[] x { get { return _innerobj.x; } }
+
+        public minbleicstate()
+        {
+            _innerobj = new minbleic.minbleicstate();
+        }
+
+        //
+        // Although some of declarations below are public, you should not use them
+        // They are intended for internal use only
+        //
+        private minbleic.minbleicstate _innerobj;
+        public minbleic.minbleicstate innerobj { get { return _innerobj; } }
+        public minbleicstate(minbleic.minbleicstate obj)
+        {
+            _innerobj = obj;
+        }
+    }
+
+
+    /*************************************************************************
+    This structure stores optimization report:
+    * InnerIterationsCount      number of inner iterations
+    * OuterIterationsCount      number of outer iterations
+    * NFEV                      number of gradient evaluations
+    * TerminationType           termination type (see below)
+
+    TERMINATION CODES
+
+    TerminationType field contains completion code, which can be:
+      -10   unsupported combination of algorithm settings:
+            1) StpMax is set to non-zero value,
+            AND 2) non-default preconditioner is used.
+            You can't use both features at the same moment,
+            so you have to choose one of them (and to turn
+            off another one).
+      -3    inconsistent constraints. Feasible point is
+            either nonexistent or too hard to find. Try to
+            restart optimizer with better initial
+            approximation
+       4    conditions on constraints are fulfilled
+            with error less than or equal to EpsC
+       5    MaxIts steps was taken
+       7    stopping conditions are too stringent,
+            further improvement is impossible,
+            X contains best point found so far.
+
+    ADDITIONAL FIELDS
+
+    There are additional fields which can be used for debugging:
+    * DebugEqErr                error in the equality constraints (2-norm)
+    * DebugFS                   f, calculated at projection of initial point
+                                to the feasible set
+    * DebugFF                   f, calculated at the final point
+    * DebugDX                   |X_start-X_final|
+    *************************************************************************/
+    public class minbleicreport
+    {
+        //
+        // Public declarations
+        //
+        public int inneriterationscount { get { return _innerobj.inneriterationscount; } set { _innerobj.inneriterationscount = value; } }
+        public int outeriterationscount { get { return _innerobj.outeriterationscount; } set { _innerobj.outeriterationscount = value; } }
+        public int nfev { get { return _innerobj.nfev; } set { _innerobj.nfev = value; } }
+        public int terminationtype { get { return _innerobj.terminationtype; } set { _innerobj.terminationtype = value; } }
+        public double debugeqerr { get { return _innerobj.debugeqerr; } set { _innerobj.debugeqerr = value; } }
+        public double debugfs { get { return _innerobj.debugfs; } set { _innerobj.debugfs = value; } }
+        public double debugff { get { return _innerobj.debugff; } set { _innerobj.debugff = value; } }
+        public double debugdx { get { return _innerobj.debugdx; } set { _innerobj.debugdx = value; } }
+
+        public minbleicreport()
+        {
+            _innerobj = new minbleic.minbleicreport();
+        }
+
+        //
+        // Although some of declarations below are public, you should not use them
+        // They are intended for internal use only
+        //
+        private minbleic.minbleicreport _innerobj;
+        public minbleic.minbleicreport innerobj { get { return _innerobj; } }
+        public minbleicreport(minbleic.minbleicreport obj)
+        {
+            _innerobj = obj;
+        }
+    }
+
+    /*************************************************************************
+                         BOUND CONSTRAINED OPTIMIZATION
+           WITH ADDITIONAL LINEAR EQUALITY AND INEQUALITY CONSTRAINTS
+
+    DESCRIPTION:
+    The  subroutine  minimizes  function   F(x)  of N arguments subject to any
+    combination of:
+    * bound constraints
+    * linear inequality constraints
+    * linear equality constraints
+
+    REQUIREMENTS:
+    * user must provide function value and gradient
+    * starting point X0 must be feasible or
+      not too far away from the feasible set
+    * grad(f) must be Lipschitz continuous on a level set:
+      L = { x : f(x)<=f(x0) }
+    * function must be defined everywhere on the feasible set F
+
+    USAGE:
+
+    Constrained optimization if far more complex than the unconstrained one.
+    Here we give very brief outline of the BLEIC optimizer. We strongly recommend
+    you to read examples in the ALGLIB Reference Manual and to read ALGLIB User Guide
+    on optimization, which is available at http://www.alglib.net/optimization/
+
+    1. User initializes algorithm state with MinBLEICCreate() call
+
+    2. USer adds boundary and/or linear constraints by calling
+       MinBLEICSetBC() and MinBLEICSetLC() functions.
+
+    3. User sets stopping conditions for underlying unconstrained solver
+       with MinBLEICSetInnerCond() call.
+       This function controls accuracy of underlying optimization algorithm.
+
+    4. User sets stopping conditions for outer iteration by calling
+       MinBLEICSetOuterCond() function.
+       This function controls handling of boundary and inequality constraints.
+
+    5. Additionally, user may set limit on number of internal iterations
+       by MinBLEICSetMaxIts() call.
+       This function allows to prevent algorithm from looping forever.
+
+    6. User calls MinBLEICOptimize() function which takes algorithm  state and
+       pointer (delegate, etc.) to callback function which calculates F/G.
+
+    7. User calls MinBLEICResults() to get solution
+
+    8. Optionally user may call MinBLEICRestartFrom() to solve another problem
+       with same N but another starting point.
+       MinBLEICRestartFrom() allows to reuse already initialized structure.
+
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>0:
+                    * if given, only leading N elements of X are used
+                    * if not given, automatically determined from size ofX
+        X       -   starting point, array[N]:
+                    * it is better to set X to a feasible point
+                    * but X can be infeasible, in which case algorithm will try
+                      to find feasible point first, using X as initial
+                      approximation.
+
+    OUTPUT PARAMETERS:
+        State   -   structure stores algorithm state
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleiccreate(int n, double[] x, out minbleicstate state)
+    {
+        state = new minbleicstate();
+        minbleic.minbleiccreate(n, x, state.innerobj);
+        return;
+    }
+    public static void minbleiccreate(double[] x, out minbleicstate state)
+    {
+        int n;
+
+        state = new minbleicstate();
+        n = ap.len(x);
+        minbleic.minbleiccreate(n, x, state.innerobj);
+
+        return;
+    }
+
+    /*************************************************************************
+    The subroutine is finite difference variant of MinBLEICCreate().  It  uses
+    finite differences in order to differentiate target function.
+
+    Description below contains information which is specific to  this function
+    only. We recommend to read comments on MinBLEICCreate() in  order  to  get
+    more information about creation of BLEIC optimizer.
+
+    INPUT PARAMETERS:
+        N       -   problem dimension, N>0:
+                    * if given, only leading N elements of X are used
+                    * if not given, automatically determined from size of X
+        X       -   starting point, array[0..N-1].
+        DiffStep-   differentiation step, >0
+
+    OUTPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+    NOTES:
+    1. algorithm uses 4-point central formula for differentiation.
+    2. differentiation step along I-th axis is equal to DiffStep*S[I] where
+       S[] is scaling vector which can be set by MinBLEICSetScale() call.
+    3. we recommend you to use moderate values of  differentiation  step.  Too
+       large step will result in too large truncation  errors, while too small
+       step will result in too large numerical  errors.  1.0E-6  can  be  good
+       value to start with.
+    4. Numerical  differentiation  is   very   inefficient  -   one   gradient
+       calculation needs 4*N function evaluations. This function will work for
+       any N - either small (1...10), moderate (10...100) or  large  (100...).
+       However, performance penalty will be too severe for any N's except  for
+       small ones.
+       We should also say that code which relies on numerical  differentiation
+       is  less  robust and precise. CG needs exact gradient values. Imprecise
+       gradient may slow  down  convergence, especially  on  highly  nonlinear
+       problems.
+       Thus  we  recommend to use this function for fast prototyping on small-
+       dimensional problems only, and to implement analytical gradient as soon
+       as possible.
+
+      -- ALGLIB --
+         Copyright 16.05.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleiccreatef(int n, double[] x, double diffstep, out minbleicstate state)
+    {
+        state = new minbleicstate();
+        minbleic.minbleiccreatef(n, x, diffstep, state.innerobj);
+        return;
+    }
+    public static void minbleiccreatef(double[] x, double diffstep, out minbleicstate state)
+    {
+        int n;
+
+        state = new minbleicstate();
+        n = ap.len(x);
+        minbleic.minbleiccreatef(n, x, diffstep, state.innerobj);
+
+        return;
+    }
+
+    /*************************************************************************
+    This function sets boundary constraints for BLEIC optimizer.
+
+    Boundary constraints are inactive by default (after initial creation).
+    They are preserved after algorithm restart with MinBLEICRestartFrom().
+
+    INPUT PARAMETERS:
+        State   -   structure stores algorithm state
+        BndL    -   lower bounds, array[N].
+                    If some (all) variables are unbounded, you may specify
+                    very small number or -INF.
+        BndU    -   upper bounds, array[N].
+                    If some (all) variables are unbounded, you may specify
+                    very large number or +INF.
+
+    NOTE 1: it is possible to specify BndL[i]=BndU[i]. In this case I-th
+    variable will be "frozen" at X[i]=BndL[i]=BndU[i].
+
+    NOTE 2: this solver has following useful properties:
+    * bound constraints are always satisfied exactly
+    * function is evaluated only INSIDE area specified by  bound  constraints,
+      even  when  numerical  differentiation is used (algorithm adjusts  nodes
+      according to boundary constraints)
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetbc(minbleicstate state, double[] bndl, double[] bndu)
+    {
+
+        minbleic.minbleicsetbc(state.innerobj, bndl, bndu);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets linear constraints for BLEIC optimizer.
+
+    Linear constraints are inactive by default (after initial creation).
+    They are preserved after algorithm restart with MinBLEICRestartFrom().
+
+    INPUT PARAMETERS:
+        State   -   structure previously allocated with MinBLEICCreate call.
+        C       -   linear constraints, array[K,N+1].
+                    Each row of C represents one constraint, either equality
+                    or inequality (see below):
+                    * first N elements correspond to coefficients,
+                    * last element corresponds to the right part.
+                    All elements of C (including right part) must be finite.
+        CT      -   type of constraints, array[K]:
+                    * if CT[i]>0, then I-th constraint is C[i,*]*x >= C[i,n+1]
+                    * if CT[i]=0, then I-th constraint is C[i,*]*x  = C[i,n+1]
+                    * if CT[i]<0, then I-th constraint is C[i,*]*x <= C[i,n+1]
+        K       -   number of equality/inequality constraints, K>=0:
+                    * if given, only leading K elements of C/CT are used
+                    * if not given, automatically determined from sizes of C/CT
+
+    NOTE 1: linear (non-bound) constraints are satisfied only approximately:
+    * there always exists some minor violation (about Epsilon in magnitude)
+      due to rounding errors
+    * numerical differentiation, if used, may  lead  to  function  evaluations
+      outside  of the feasible  area,   because   algorithm  does  NOT  change
+      numerical differentiation formula according to linear constraints.
+    If you want constraints to be  satisfied  exactly, try to reformulate your
+    problem  in  such  manner  that  all constraints will become boundary ones
+    (this kind of constraints is always satisfied exactly, both in  the  final
+    solution and in all intermediate points).
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetlc(minbleicstate state, double[,] c, int[] ct, int k)
+    {
+
+        minbleic.minbleicsetlc(state.innerobj, c, ct, k);
+        return;
+    }
+    public static void minbleicsetlc(minbleicstate state, double[,] c, int[] ct)
+    {
+        int k;
+        if( (ap.rows(c)!=ap.len(ct)))
+            throw new alglibexception("Error while calling 'minbleicsetlc': looks like one of arguments has wrong size");
+
+        k = ap.rows(c);
+        minbleic.minbleicsetlc(state.innerobj, c, ct, k);
+
+        return;
+    }
+
+    /*************************************************************************
+    This function sets stopping conditions for the underlying nonlinear CG
+    optimizer. It controls overall accuracy of solution. These conditions
+    should be strict enough in order for algorithm to converge.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        EpsG    -   >=0
+                    The  subroutine  finishes  its  work   if   the  condition
+                    |v|<EpsG is satisfied, where:
+                    * |.| means Euclidian norm
+                    * v - scaled gradient vector, v[i]=g[i]*s[i]
+                    * g - gradient
+                    * s - scaling coefficients set by MinBLEICSetScale()
+        EpsF    -   >=0
+                    The  subroutine  finishes  its work if on k+1-th iteration
+                    the  condition  |F(k+1)-F(k)|<=EpsF*max{|F(k)|,|F(k+1)|,1}
+                    is satisfied.
+        EpsX    -   >=0
+                    The subroutine finishes its work if  on  k+1-th  iteration
+                    the condition |v|<=EpsX is fulfilled, where:
+                    * |.| means Euclidian norm
+                    * v - scaled step vector, v[i]=dx[i]/s[i]
+                    * dx - ste pvector, dx=X(k+1)-X(k)
+                    * s - scaling coefficients set by MinBLEICSetScale()
+
+    Passing EpsG=0, EpsF=0 and EpsX=0 (simultaneously) will lead to
+    automatic stopping criterion selection.
+
+    These conditions are used to terminate inner iterations. However, you
+    need to tune termination conditions for outer iterations too.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetinnercond(minbleicstate state, double epsg, double epsf, double epsx)
+    {
+
+        minbleic.minbleicsetinnercond(state.innerobj, epsg, epsf, epsx);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets stopping conditions for outer iteration of BLEIC algo.
+
+    These conditions control accuracy of constraint handling and amount of
+    infeasibility allowed in the solution.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        EpsX    -   >0, stopping condition on outer iteration step length
+        EpsI    -   >0, stopping condition on infeasibility
+
+    Both EpsX and EpsI must be non-zero.
+
+    MEANING OF EpsX
+
+    EpsX  is  a  stopping  condition for outer iterations. Algorithm will stop
+    when  solution  of  the  current  modified  subproblem will be within EpsX
+    (using 2-norm) of the previous solution.
+
+    MEANING OF EpsI
+
+    EpsI controls feasibility properties -  algorithm  won't  stop  until  all
+    inequality constraints will be satisfied with error (distance from current
+    point to the feasible area) at most EpsI.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetoutercond(minbleicstate state, double epsx, double epsi)
+    {
+
+        minbleic.minbleicsetoutercond(state.innerobj, epsx, epsi);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets scaling coefficients for BLEIC optimizer.
+
+    ALGLIB optimizers use scaling matrices to test stopping  conditions  (step
+    size and gradient are scaled before comparison with tolerances).  Scale of
+    the I-th variable is a translation invariant measure of:
+    a) "how large" the variable is
+    b) how large the step should be to make significant changes in the function
+
+    Scaling is also used by finite difference variant of the optimizer  - step
+    along I-th axis is equal to DiffStep*S[I].
+
+    In  most  optimizers  (and  in  the  BLEIC  too)  scaling is NOT a form of
+    preconditioning. It just  affects  stopping  conditions.  You  should  set
+    preconditioner  by  separate  call  to  one  of  the  MinBLEICSetPrec...()
+    functions.
+
+    There is a special  preconditioning  mode, however,  which  uses   scaling
+    coefficients to form diagonal preconditioning matrix. You  can  turn  this
+    mode on, if you want.   But  you should understand that scaling is not the
+    same thing as preconditioning - these are two different, although  related
+    forms of tuning solver.
+
+    INPUT PARAMETERS:
+        State   -   structure stores algorithm state
+        S       -   array[N], non-zero scaling coefficients
+                    S[i] may be negative, sign doesn't matter.
+
+      -- ALGLIB --
+         Copyright 14.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetscale(minbleicstate state, double[] s)
+    {
+
+        minbleic.minbleicsetscale(state.innerobj, s);
+        return;
+    }
+
+    /*************************************************************************
+    Modification of the preconditioner: preconditioning is turned off.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetprecdefault(minbleicstate state)
+    {
+
+        minbleic.minbleicsetprecdefault(state.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Modification  of  the  preconditioner:  diagonal of approximate Hessian is
+    used.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        D       -   diagonal of the approximate Hessian, array[0..N-1],
+                    (if larger, only leading N elements are used).
+
+    NOTE 1: D[i] should be positive. Exception will be thrown otherwise.
+
+    NOTE 2: you should pass diagonal of approximate Hessian - NOT ITS INVERSE.
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetprecdiag(minbleicstate state, double[] d)
+    {
+
+        minbleic.minbleicsetprecdiag(state.innerobj, d);
+        return;
+    }
+
+    /*************************************************************************
+    Modification of the preconditioner: scale-based diagonal preconditioning.
+
+    This preconditioning mode can be useful when you  don't  have  approximate
+    diagonal of Hessian, but you know that your  variables  are  badly  scaled
+    (for  example,  one  variable is in [1,10], and another in [1000,100000]),
+    and most part of the ill-conditioning comes from different scales of vars.
+
+    In this case simple  scale-based  preconditioner,  with H[i] = 1/(s[i]^2),
+    can greatly improve convergence.
+
+    IMPRTANT: you should set scale of your variables  with  MinBLEICSetScale()
+    call  (before  or after MinBLEICSetPrecScale() call). Without knowledge of
+    the scale of your variables scale-based preconditioner will be  just  unit
+    matrix.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+
+      -- ALGLIB --
+         Copyright 13.10.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetprecscale(minbleicstate state)
+    {
+
+        minbleic.minbleicsetprecscale(state.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    This function allows to stop algorithm after specified number of inner
+    iterations.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        MaxIts  -   maximum number of inner iterations.
+                    If MaxIts=0, the number of iterations is unlimited.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetmaxits(minbleicstate state, int maxits)
+    {
+
+        minbleic.minbleicsetmaxits(state.innerobj, maxits);
+        return;
+    }
+
+    /*************************************************************************
+    This function turns on/off reporting.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        NeedXRep-   whether iteration reports are needed or not
+
+    If NeedXRep is True, algorithm will call rep() callback function if  it is
+    provided to MinBLEICOptimize().
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetxrep(minbleicstate state, bool needxrep)
+    {
+
+        minbleic.minbleicsetxrep(state.innerobj, needxrep);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets maximum step length
+
+    IMPORTANT: this feature is hard to combine with preconditioning. You can't
+    set upper limit on step length, when you solve optimization  problem  with
+    linear (non-boundary) constraints AND preconditioner turned on.
+
+    When  non-boundary  constraints  are  present,  you  have to either a) use
+    preconditioner, or b) use upper limit on step length.  YOU CAN'T USE BOTH!
+    In this case algorithm will terminate with appropriate error code.
+
+    INPUT PARAMETERS:
+        State   -   structure which stores algorithm state
+        StpMax  -   maximum step length, >=0. Set StpMax to 0.0,  if you don't
+                    want to limit step length.
+
+    Use this subroutine when you optimize target function which contains exp()
+    or  other  fast  growing  functions,  and optimization algorithm makes too
+    large  steps  which  lead   to overflow. This function allows us to reject
+    steps  that  are  too  large  (and  therefore  expose  us  to the possible
+    overflow) without actually calculating function value at the x+stp*d.
+
+      -- ALGLIB --
+         Copyright 02.04.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicsetstpmax(minbleicstate state, double stpmax)
+    {
+
+        minbleic.minbleicsetstpmax(state.innerobj, stpmax);
+        return;
+    }
+
+    /*************************************************************************
+    This function provides reverse communication interface
+    Reverse communication interface is not documented or recommended to use.
+    See below for functions which provide better documented API
+    *************************************************************************/
+    public static bool minbleiciteration(minbleicstate state)
+    {
+
+        bool result = minbleic.minbleiciteration(state.innerobj);
+        return result;
+    }
+    /*************************************************************************
+    This family of functions is used to launcn iterations of nonlinear optimizer
+
+    These functions accept following parameters:
+        func    -   callback which calculates function (or merit function)
+                    value func at given point x
+        grad    -   callback which calculates function (or merit function)
+                    value func and gradient grad at given point x
+        rep     -   optional callback which is called after each iteration
+                    can be null
+        obj     -   optional object which is passed to func/grad/hess/jac/rep
+                    can be null
+
+    NOTES:
+
+    1. This function has two different implementations: one which  uses  exact
+       (analytical) user-supplied gradient,  and one which uses function value
+       only  and  numerically  differentiates  function  in  order  to  obtain
+       gradient.
+
+       Depending  on  the  specific  function  used to create optimizer object
+       (either  MinBLEICCreate() for analytical gradient or  MinBLEICCreateF()
+       for numerical differentiation) you should choose appropriate variant of
+       MinBLEICOptimize() - one  which  accepts  function  AND gradient or one
+       which accepts function ONLY.
+
+       Be careful to choose variant of MinBLEICOptimize() which corresponds to
+       your optimization scheme! Table below lists different  combinations  of
+       callback (function/gradient) passed to MinBLEICOptimize()  and specific
+       function used to create optimizer.
+
+
+                         |         USER PASSED TO MinBLEICOptimize()
+       CREATED WITH      |  function only   |  function and gradient
+       ------------------------------------------------------------
+       MinBLEICCreateF() |     work                FAIL
+       MinBLEICCreate()  |     FAIL                work
+
+       Here "FAIL" denotes inappropriate combinations  of  optimizer  creation
+       function  and  MinBLEICOptimize()  version.   Attemps   to   use   such
+       combination (for  example,  to  create optimizer with MinBLEICCreateF()
+       and  to  pass  gradient  information  to  MinCGOptimize()) will lead to
+       exception being thrown. Either  you  did  not pass gradient when it WAS
+       needed or you passed gradient when it was NOT needed.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+
+    *************************************************************************/
+    public static void minbleicoptimize(minbleicstate state, ndimensional_func func, ndimensional_rep rep, object obj)
+    {
+        if( func==null )
+            throw new alglibexception("ALGLIB: error in 'minbleicoptimize()' (func is null)");
+        while( alglib.minbleiciteration(state) )
+        {
+            if( state.needf )
+            {
+                func(state.x, ref state.innerobj.f, obj);
+                continue;
+            }
+            if( state.innerobj.xupdated )
+            {
+                if( rep!=null )
+                    rep(state.innerobj.x, state.innerobj.f, obj);
+                continue;
+            }
+            throw new alglibexception("ALGLIB: error in 'minbleicoptimize' (some derivatives were not provided?)");
+        }
+    }
+
+
+    public static void minbleicoptimize(minbleicstate state, ndimensional_grad grad, ndimensional_rep rep, object obj)
+    {
+        if( grad==null )
+            throw new alglibexception("ALGLIB: error in 'minbleicoptimize()' (grad is null)");
+        while( alglib.minbleiciteration(state) )
+        {
+            if( state.needfg )
+            {
+                grad(state.x, ref state.innerobj.f, state.innerobj.g, obj);
+                continue;
+            }
+            if( state.innerobj.xupdated )
+            {
+                if( rep!=null )
+                    rep(state.innerobj.x, state.innerobj.f, obj);
+                continue;
+            }
+            throw new alglibexception("ALGLIB: error in 'minbleicoptimize' (some derivatives were not provided?)");
+        }
+    }
+
+
+
+    /*************************************************************************
+    BLEIC results
+
+    INPUT PARAMETERS:
+        State   -   algorithm state
+
+    OUTPUT PARAMETERS:
+        X       -   array[0..N-1], solution
+        Rep     -   optimization report. You should check Rep.TerminationType
+                    in  order  to  distinguish  successful  termination  from
+                    unsuccessful one.
+                    More information about fields of this  structure  can  be
+                    found in the comments on MinBLEICReport datatype.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicresults(minbleicstate state, out double[] x, out minbleicreport rep)
+    {
+        x = new double[0];
+        rep = new minbleicreport();
+        minbleic.minbleicresults(state.innerobj, ref x, rep.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    BLEIC results
+
+    Buffered implementation of MinBLEICResults() which uses pre-allocated buffer
+    to store X[]. If buffer size is  too  small,  it  resizes  buffer.  It  is
+    intended to be used in the inner cycles of performance critical algorithms
+    where array reallocation penalty is too large to be ignored.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicresultsbuf(minbleicstate state, ref double[] x, minbleicreport rep)
+    {
+
+        minbleic.minbleicresultsbuf(state.innerobj, ref x, rep.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    This subroutine restarts algorithm from new point.
+    All optimization parameters (including constraints) are left unchanged.
+
+    This  function  allows  to  solve multiple  optimization  problems  (which
+    must have  same number of dimensions) without object reallocation penalty.
+
+    INPUT PARAMETERS:
+        State   -   structure previously allocated with MinBLEICCreate call.
+        X       -   new starting point.
+
+      -- ALGLIB --
+         Copyright 28.11.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minbleicrestartfrom(minbleicstate state, double[] x)
+    {
+
+        minbleic.minbleicrestartfrom(state.innerobj, x);
+        return;
+    }
+
+}
+public partial class alglib
+{
+
+
+    /*************************************************************************
 
     *************************************************************************/
